#include "Autopilot.h"




void heading_controller::compute()
{
	if (timer.fire() && modeType == ON)
	{
		kp = pIn;
		ki = iIn * (timer.timeDiff * 1000.0);
		kd = dIn / (timer.timeDiff * 1000.0);

		if (direction == BACKWARD)
		{
			kp *= -1;
			ki *= -1;
			kd *= -1;
		}

		lastInput = curInput;
		lastSetpoint = curSetpoint;
		lastError = curError;

		curInput = *input;
		curSetpoint = *setpoint;
		curError = acuteAngle(curInput, curSetpoint);

		double dInput = fmod(curInput - lastInput + 360, 360);

		if (pOnType == P_ON_E)
			pOut = kp * curError;
		else if (pOnType == P_ON_M)
			pOut = -kp * dInput;

		iOut += (ki * ((curError + lastError) / 2.0)); // Trapezoidal integration
		iOut = constrain(iOut, windupMin, windupMax);  // Prevent integral windup

		dOut = -kd * dInput; // Derrivative on measurement

		double newOutput = bias + pOut + iOut + dOut;
		newOutput = constrain(newOutput, outputMin, outputMax);
		*output = newOutput;
	}
}
